﻿var wsUrl="ws://127.0.0.1:9866"
var socket_scan=null;
var lockReconnect=false; //避免心跳重复连接
var upload_filename=[];


createWebSocket(get_appropriate_ws_url());
var BrowserDetect =
	{
		init: function () {
			this.getOsVersion();
			this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
			this.version = this.searchVersion(navigator.userAgent) || this.searchVersion(navigator.appVersion) || "an unknown version";
			this.OS = this.searchString(this.dataOS) || "an unknown OS";
		},
		searchString: function (data) {
			for (var i = 0; i < data.length; i++) {
				var dataString = data[i].string;
				var dataProp = data[i].prop;
				this.versionSearchString = data[i].versionSearch || data[i].identity;
				if (dataString) {
					if (dataString.indexOf(data[i].subString) != -1)
						return data[i].identity;
				} else if (dataProp)
					return data[i].identity;
			}
		},
		searchVersion: function (dataString) {
			var index = dataString.indexOf(this.versionSearchString);
			if (index == -1) return;
			return parseFloat(dataString.substring(index + this.versionSearchString.length + 1));
		},

		dataBrowser: [{
			string: navigator.userAgent,
			subString: "Chrome",
			identity: "Chrome"
		},
			{
				string: navigator.userAgent,
				subString: "OmniWeb",
				versionSearch: "OmniWeb/",
				identity: "OmniWeb"
			},
			{
				string: navigator.vendor,
				subString: "Apple",
				identity: "Safari",
				versionSearch: "Version"
			},
			{
				prop: window.opera,
				identity: "Opera",
				versionSearch: "Version"
			},
			{
				string: navigator.vendor,
				subString: "iCab",
				identity: "iCab"
			},
			{
				string: navigator.vendor,
				subString: "KDE",
				identity: "Konqueror"
			},
			{
				string: navigator.userAgent,
				subString: "Firefox",
				identity: "Firefox"
			},
			{
				string: navigator.vendor,
				subString: "Camino",
				identity: "Camino"
			},
			{ // for newer Netscapes (6+)
				string: navigator.userAgent,
				subString: "Netscape",
				identity: "Netscape"
			},
			{
				string: navigator.userAgent,
				subString: "MSIE",
				identity: "Explorer",
				versionSearch: "MSIE"
			},
			{
				string: navigator.userAgent,
				subString: "Gecko",
				identity: "Mozilla",
				versionSearch: "rv"
			},
			{ // for older Netscapes (4-)
				string: navigator.userAgent,
				subString: "Mozilla",
				identity: "Netscape",
				versionSearch: "Mozilla"
			}],
		dataOS: [{
			string: navigator.platform,
			subString: "Win",
			identity: "Windows"
		},
			{
				string: navigator.platform,
				subString: "Mac",
				identity: "Mac"
			},
			{
				string: navigator.userAgent,
				subString: "iPhone",
				identity: "iPhone/iPod"
			},
			{
				string: navigator.platform,
				subString: "Linux",
				identity: "Linux"
			}],
		//"Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.143 Safari/537.36"
		getOsVersion: function () {
			var osVersion = navigator.userAgent;
			var listVersion = ["Windows NT 5.1", "Windows NT 6.1", "Windows NT 6.2", "Windows NT 10.0"];
			var listVerName = ["Xp", "7", "8", "10"];
			if (navigator.platform == "Win32") {
				for (var index = 0; index < listVersion.length; index++) {
					if (osVersion.search(listVersion[index]) != -1) {
						this.osVersion = listVerName[index];
					}
				}
				if (osVersion.search("WOW64") != -1 || osVersion.search("Win64") != -1) {
					this.osBit = "64";
				} else {
					this.osBit = "32";
				}
			} else {
				this.osVersion = "";
				this.osBit = "";
			}

		}
	};
			BrowserDetect.init();
			document.getElementById("brow_txt").textContent = BrowserDetect.browser + " " + BrowserDetect.version
													+" " +BrowserDetect.OS + " " +BrowserDetect.osVersion +" " + BrowserDetect.osBit;

//心跳重连
	var heartCheck = {
		timeout: 60000,        //1分钟发一次心跳
		timeoutObj: null,
		serverTimeoutObj: null,
		reset: function () {
			clearTimeout(this.timeoutObj);
			clearTimeout(this.serverTimeoutObj);
			return this;
		},
		start: function () {
			var self = this;
			this.timeoutObj = setTimeout(function () {
				//这里发送一个心跳，后端收到后，返回一个心跳消息，
				//onmessage拿到返回的心跳就说明连接正常
			jsonPing =
				{
					"type": "CMD_ORDER",
					"cmd": "Ping"
				}
				socket_scan.send(JSON.stringify(jsonPing));
			console.log("ping!")
			self.serverTimeoutObj = setTimeout(function () {//如果超过一定时间还没重置，说明后端主动断开了
				socket_scan.close();     //如果onclose会执行reconnect，我们执行ws.close()就行了.如果直接执行reconnect 会触发onclose导致重连两次
			}, self.timeout)
		}, this.timeout)
	}
}
	function get_appropriate_ws_url() 
	{
		var pcol;
		var u = document.URL;
		var ul=window.location.host;
		/*
		* We open the websocket encrypted if this page came on an
		* https:// url itself, otherwise unencrypted
		*/
		if (u.substring(0, 5) == "https") {
			pcol = "wss://localhost:";
		} 
		else 
		{ 
			//pcol = "ws://localhost:";
			pcol = "ws://127.0.0.1:";
			//pcol = "wss://localhost:";
		//	pcol  = "ws://172.16.8.87:9000";
		}
		/* + "/xxx" bit is for IE10 workaround */
		pcol += "9866";
		return pcol;
	}
	
	
	function createWebSocket(url) {
		try {

			if (typeof MozWebSocket != "undefined") {
				socket_scan = new MozWebSocket(get_appropriate_ws_url(), "scanner-h5-protocol");
			} else {
				socket_scan = new WebSocket(get_appropriate_ws_url(), "scanner-h5-protocol");
			}
			initEventHandle();
		} catch (e) {
			reconnect(url);
			console.log(e);
		}
	}


		function initEventHandle() {
			try {
				socket_scan.onopen = function () {
					heartCheck.reset().start();
					jsonPing =
						{
							"type": "CMD_ORDER",
							"cmd": "Ping"
						}
					socket_scan.send(JSON.stringify(jsonPing));
					document.getElementById("wsdi_statustd").style.backgroundColor = "#15A848";
					document.getElementById("wsdi_txt").innerHTML = "已连接扫描仪服务";// + BrowserDetect.browser + " " + BrowserDetect.version + " " +  BrowserDetect.OS ;
					//document.getElementById("disimg").src ="img-upload/leaf.jpg";
				}
				var total = 0;
				var imgBase64 = "";
				socket_scan.onmessage = function got_packet(msg) {
					heartCheck.reset().start();
					var dat = msg.data;
					//console.log("msg from ws: " + dat);
					//return;
					jsonDat = JSON.parse(dat);
					//	alert(jsonDat.type);

					if (jsonDat.type == "STATUS") {
						if (jsonDat.data == "not_ready") {

							console.log(jsonDat.data);
						} else if (jsonDat.data == "task_done") {
							//Post(upload_filename);
							var str = jsonDat.data + "页数" + jsonDat.num;
							console.log(str);
							console.log(upload_filename);
							var length = upload_filename.length;

							upload_filename.splice(0, upload_filename.length);
							//console.log(jsonDat.num);
						} else if (jsonDat.data == "scan_error") {
							var str = jsonDat.data + "错误码" + jsonDat.error_code;
							console.log(str);
						} else if (jsonDat.data == "upload_done") {

							var str = jsonDat.data + "UPLOAD回传信息：" + jsonDat.response;
							console.log(str);
						} else if(jsonDat.data == "upload_done_base64") {
							var str = jsonDat.data + "总共上传的图片张数：" + jsonDat.num;
							console.log(str);
						}
						else{
							console.log(jsonDat.data);

						}

						//console.log(jsonDat.error_code);
					} else if (jsonDat.type == "FILE_NAME") {
						<!-- console.log("file name:" + jsonDat.filename); -->
						<!-- console.log("index:" + jsonDat.index); -->
						<!-- console.log("fragment:"+ jsonDat.fragment); -->
						<!-- console.log("base64 size:" + jsonDat.size); -->
						<!-- console.log("fragment size:" + jsonDat.base64.length); -->

						console.log("fragment:"+ jsonDat.fragment);

						//Post(jsonDat.filename);
						upload_filename.push(jsonDat.filename);
						//Post(jsonDat.filename);
						total += jsonDat.base64.length;

							imgBase64 += jsonDat.base64;
						if (jsonDat.fragment == "WRITE_FIN") {

							// if (total == jsonDat.size)
							if(1)
							{
								console.log('收到文件 :' + jsonDat.filename + ' siez:' + total);
								var img = document.createElement('img');
								img.src = "data:image/jpg;base64," + imgBase64;
								img.width = 300;
								document.querySelector('.preview').appendChild(img);
								document.getElementById("disimg").src = "data:image/jpg;base64," + imgBase64;
							} else
								console.log('接收完毕,校验失败');
							total = 0;
							//console.log(imgBase64);
							imgBase64 = "";
						}
					} else if (jsonDat.type == "DS_LIST") {
						//alert("jsonDat.type == DS_LIST");
						console.log(jsonDat.data);

						var tmp = jsonDat.data + "";//转成字符串
						var arr = tmp.split(",");
						var TwainSource = document.getElementById("alldsname");
						//TwainSource.
						for(i=TwainSource.options.length-1 ; i>= 0 ; i--){
							TwainSource.options[i] = null;
						}
						for (var i = 0; i < arr.length; i++) {
							var option = new Option(arr[i], i);
							TwainSource.options.add(option);
						}
					} else if (jsonDat.type == "Ping") {
						console.log(jsonDat.data);

					}

				}

				socket_scan.onclose = function () {
					document.getElementById("wsdi_statustd").style.backgroundColor = "#ff4040"; //#15"#40ff40"
					document.getElementById("wsdi_txt").textContent = "已断开扫描仪服务";

					reconnect(get_appropriate_ws_url());
					//document.getElementById("brow_txt").textContent =  BrowserDetect.browser + " " + BrowserDetect.version + " " +  BrowserDetect.OS ;
				}
			} catch (exception) {
				console.log('<p>Error' + exception);
			}
		}




	window.onbeforeunload = function() {
		socket_scan.close();
	}

		var custom_cmd =
			{
				"dsname": "Uniscan Q350",
				"customOnUI": "show"
			}; //+ CRJ 2016-11-22 17:35:51


		//document.getElementById("number").textContent = get_appropriate_ws_url();

		/* dumb increment protocol */


		function getSelectedValue(id) {
			var val, obj, index;
			obj = document.getElementById(id);
			if (obj != null) {
				index = obj.selectedIndex;
				val = obj.options[index].text;
				return val;
			} else
				return "";
		}


		function getSelectedCheck(id) {
			var obj = document.getElementById(id);
			if (obj != null) {
				var val = obj.checked;
				//alert(val);
				if (val == true)
					return "true";
				else
					return "false";
			}
			return "false";
		}


		function reconnect(url) {
			if (lockReconnect) return;
			lockReconnect = true;
			setTimeout(function () {      //没连接上会一直重连，设置延迟避免请求过多
				createWebSocket(url);
				lockReconnect = false;
			}, 2000);
		}



